#include "verbimorfo.hh"
#include "nominimorfo.hh"
#include "argh/argh.hh"

#include <string>
#include <cstdio>
using std::string;
using std::printf;
using std::fprintf;

bool debugflag = false;

int main(int argc, const char *const *argv)
{
    bool nega = false;
    string pers = "pas";
    string aika = "preesens";
    string tapa = "ind";
    string sija = "nom";
    string medipre = "";
    bool monikko = false;
    bool passiivi = false;
    int verbose = 0;
    
    ParamHandler Argh;
    Argh.AddLong("help",   'h').SetBool().SetDesc("Tm ohje.");
    Argh.AddLong("version",'V').SetBool().SetDesc("Tulostaa versiotiedon.");
    Argh.AddLong("pers",   'p').SetString().SetDesc("Valitse persoonamuoto/omistusliite (yks1,yks2,yks3,mon1,mon2,mon3,pass)", "<muoto>");
    Argh.AddLong("nega",   'n').SetBool().SetDesc("Valitse negaatio (finiittien verbien taivutukseen)");
    Argh.AddLong("moni",   'l').SetBool().SetDesc("Valitse monikko (nominien ja nominaalien taivutukseen)");
    Argh.AddLong("pass",   'a').SetBool().SetDesc("Valitse passiivi (partisiippien ja III infinitiivin taivutukseen)");
    Argh.AddLong("aika",   't').SetString().SetDesc("Valitse aikamuoto (pr,i,pe,pl finiittien verbien taivutukseen)", "<aika>");
    Argh.AddLong("tapa",   'm').SetString().SetDesc("Valitse tapaluokka (ind,kond,pot,imp,[1-5]i,1p,2p,suor,johto[1-6]) (verbin taivutukseen)", "<tapa>");
    Argh.AddLong("sija",   'j').SetString().SetDesc("Valitse sijamuoto (nom,gen,ak,es,pa,tr,ine,el,il,ade,abl,al,abe,kom,ins)", "<sija>");
    Argh.AddLong("medipre",'M').SetString().SetDesc("Mediaalinen esiksittely verbeille (a/p)", "<mjono>");
    Argh.AddLong("verbose",'v').SetBool().SetDesc("Lis tulostettavan tiedon mr.");
    Argh.AddLong("debug",  'd').SetBool().SetDesc("Debug.");
    
    Argh.StartParse(argc, argv);
    bool sanoja = false;
    int c;
    for(; (c=Argh.GetParam()) != -1; ++c)
    {
        switch(c)
        {
            case 'V': printf("%s\n", VERSION); return 0;
            case 'p': pers = Argh.GetString(); break;
            case 'n': nega = Argh.GetBool(); break;
            case 't': aika = Argh.GetString(); break;
            case 'm': tapa = Argh.GetString(); break;
            case 'j': sija = Argh.GetString(); break;
            case 'M': medipre = Argh.GetString(); break;
            case 'l': monikko = Argh.GetBool(); break;
            case 'a': passiivi = Argh.GetBool(); break;
            case 'v': if(Argh.GetBool())++verbose;else --verbose; break;
            case 'd': debugflag = Argh.GetBool(); break;
            case 'h':
                if(Argh.GetBool())
                {
            Help:   printf(
                        "formodemo v"VERSION" - Copyright (C) 1992,2005 Bisqwit (http://iki.fi/bisqwit/)\n"
                        "Kiitokset Juha Niemiselle avusta.\n"
                        "\n"
                        "Kytt: %s [<option> [<...>]] <sana> [<...>]\n"
                        "\n"
                        "Valitsimet:\n", argv[0]);
                    Argh.ListOptions();
                    printf(
                        "\nHuom: Laita taivutettavat sanat komentorivin loppuun.\n"
                        "Uudet valitsimet vaikuttavat vain sit seuraaviin sanoihin.\n");
                    return 0;
                }
                break;
            default:
            {
                string word = Argh.GetString();
                
                for(unsigned m=0; m<medipre.size(); ++m)
                {
                    if(medipre[m]=='a')
                        word = Mediaaliksi(word, false);
                    else if(medipre[m]=='p')
                        word = Mediaaliksi(word, true);
                    else
                    {
                        fprintf(stderr, "%s: Unknown medial key: '%c' ('a' and 'p' are known)\n",
                            word.c_str(), medipre[m]);
                    }
                }

                string result;
                
                aikamuoto a;
                sijamuoto j;
                persoona p;
                tapaluokka t;
                
/* The following code has been generated by hashes from hashes.txt */
#include "mainhash.inc"

                if(nega && t != INDIKATIIVI && t != KONDITIONAALI && t != POTENTIAALI && t != IMPERATIIVI)
                {
                    fprintf(stderr, "%s: Negaatio soveltuu vain finiitteihin verbeihin. Negaatio jtetty huomiotta.\n", word.c_str());
                    nega = false;
                }
                if(passiivi && t != PARTISIIPPI1 && t != PARTISIIPPI2 && t != INFINITIIVI2 && t != INFINITIIVI3)
                {
                    fprintf(stderr, "%s: -a (passiivi) -vipu soveltuu vain partisiippeihin ja II ja III infinitiiviin.\n"
                                    "Jos haluat saada muunlaisen verbin passiivimuotoon, valitse passiivinen persoona -ppass -vivulla.\n", word.c_str());
                }
                if(j != NOMINATIIVI && (t == INDIKATIIVI || t == KONDITIONAALI || t == POTENTIAALI || t == IMPERATIIVI))
                {
                    fprintf(stderr, "%s: Finiiteill verbeill ei ole sijamuotoja. Sijamuotomritys jtetty huomiotta.\n", word.c_str());
                    j = NOMINATIIVI;
                }
                sanoja = true;
                
                string sana = word;
                switch(t)
                {
                    case INDIKATIIVI:      word = Indikatiiviksi(word,a,p,!nega); break;
                    case KONDITIONAALI:    word = Konditionaaliksi(word,a,p,!nega); break;
                    case POTENTIAALI:      word = Potentiaaliksi(word,a,p,!nega); break;
                    case IMPERATIIVI:      word = Imperatiiviksi(word,a,p,!nega); break;
                    case PARTISIIPPI1:     word = Partisiipiksi1(word,passiivi); break;
                    case PARTISIIPPI2:     word = Partisiipiksi2(word,passiivi); break;
                    case INFINITIIVI1:     word = Infinitiiviksi1(word); InfiniMuotoTarkistus(1, word, j, monikko, p); break;
                    case INFINITIIVI2:     word = Infinitiiviksi2(word,passiivi); InfiniMuotoTarkistus(2, word, j, monikko, p); break;
                    case INFINITIIVI3:     word = Infinitiiviksi3(word,passiivi); InfiniMuotoTarkistus(3, word, j, monikko, p); break;
                    case INFINITIIVI4:     word = Infinitiiviksi4(word); InfiniMuotoTarkistus(4, word, j, monikko, p); break;
                    case INFINITIIVI5:     word = Infinitiiviksi5(word); InfiniMuotoTarkistus(5, word, j, monikko, p); break;
                    case JOHTO1:           word = JohdaVerbi1(word); break;
                    case JOHTO2:           word = JohdaVerbi2(word); break;
                    case JOHTO3:           word = JohdaVerbi3(word); break;
                    case JOHTO4:           word = JohdaVerbi4(word); break;
                    case JOHTO5:           word = JohdaVerbi5(word); break;
                    case JOHTO6:           word = JohdaVerbi6(word); break;
                    case SUORITTAJA:       word = Suorittajaksi(word); break;
                }
                switch(t)
                {
                    case INDIKATIIVI:
                    case KONDITIONAALI:
                    case POTENTIAALI:
                    case IMPERATIIVI:
                        // Nit ei voi taivuttaa nomineina
                        break;
                    case INFINITIIVI1:
                    case INFINITIIVI2:
                    case INFINITIIVI3:
                    case INFINITIIVI4:
                    case INFINITIIVI5:
                        // Nille on omat taivutussntns
                        word = InfiniTaivutus(word, j, monikko, p);
                        break;
                    case PARTISIIPPI1:
                    case PARTISIIPPI2:
                    case JOHTO1:
                    case JOHTO2:
                    case JOHTO3:
                    case JOHTO4:
                    case JOHTO5:
                    case JOHTO6:
                    case SUORITTAJA:
                        // Nit voi taivuttaa nomineina
                        word = NominiTaivutus(word, j, monikko, p);
                        break;
                }
                switch(t)
                {
                    case INDIKATIIVI:      printf("Indikatiivi: '%s'\n", word.c_str()); break;
                    case KONDITIONAALI:    printf("Konditionaali: '%s'\n", word.c_str()); break;
                    case POTENTIAALI:      printf("Potentiaali: '%s'\n", word.c_str()); break;
                    case IMPERATIIVI:      printf("Imperatiivi: '%s'\n", word.c_str()); break;
                    case PARTISIIPPI1:     printf("I partisiippi: '%s'\n", word.c_str()); break;
                    case PARTISIIPPI2:     printf("II partisiippi: '%s'\n", word.c_str()); break;
                    case INFINITIIVI1:     printf("I infinitiivi: '%s'\n",   word.c_str()); break;
                    case INFINITIIVI2:     printf("II infinitiivi: '%s'\n",  word.c_str()); break;
                    case INFINITIIVI3:     printf("III infinitiivi: '%s'\n", word.c_str()); break;
                    case INFINITIIVI4:     printf("IV infinitiivi: '%s'\n",  word.c_str()); break;
                    case INFINITIIVI5:     printf("V infinitiivi: '%s'\n",   word.c_str()); break;
                    case JOHTO1:
                    case JOHTO2:
                    case JOHTO3:
                    case JOHTO4:
                    case JOHTO5:
                    case JOHTO6:           printf("Johdos: '%s'\n", word.c_str()); break;
                    case SUORITTAJA:       printf("Suorittaja: '%s'\n", word.c_str()); break;
                }
            }
        }
    }
    if(Argh.ok() && !sanoja)
    {
        fprintf(stderr, "Sanaton!\n");
        goto Help;
    }
    return 0;
}
